<?php

/*
Plugin Name: SlideShowPro Shortcode
Plugin URI:
Description: Creates shortcode button for easy insertion of SlidesShowPro slideshows within posts and pages.
Version: 1.0.1
Author: Mark Luetke
Author URI: http://luetkemj.com
*/

/*  This plugin creates shortcode buttons and a settings interface for easy insertion of SlidesShowPro slideshows within posts and pages.
    Copyright (C) 2011  Mark Luetke

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/




// create custom plugin settings menu
add_action('admin_menu', 'vcu_create_menu');

function vcu_create_menu() {

    //create new top-level menu
    add_options_page('SSP-SC Plugin Settings', 'SlideShowPro SC', 'administrator', __FILE__, 'vcu_settings_page', plugins_url('/images/wordpress.png', __FILE__)); 

    //call register settings function
    add_action( 'admin_init', 'vcu_register_settings' );
}


function vcu_register_settings() {
    //register our settings
    register_setting( 'vcu-settings-group', 'vcu_option_name' );
    register_setting( 'vcu-settings-group', 'vcu_option_width' );
    register_setting( 'vcu-settings-group', 'vcu_option_height' );
    register_setting( 'vcu-settings-group', 'vcu_option_style' );
    register_setting( 'vcu-settings-group', 'vcu_option_content_scale' );
    register_setting( 'vcu-settings-group', 'vcu_option_transition' );
    register_setting( 'vcu-settings-group', 'vcu_option_preloader' );
    register_setting( 'vcu-settings-group', 'vcu_option_auto_playback' );
    register_setting( 'vcu-settings-group', 'vcu_option_pan_zoom' );
    register_setting( 'vcu-settings-group', 'vcu_option_mouseover_navigation' );
    register_setting( 'vcu-settings-group', 'vcu_option_open_gallery' );
    register_setting( 'vcu-settings-group', 'vcu_option_auto_start_videos' );
    register_setting( 'vcu-settings-group', 'vcu_option_thumbnail_links' );
    }

function vcu_settings_page() {
?>
<div class="wrap">
<h2><?php _e('SlideShowPro Shortcode Plugin Options', 'vcu-plugin') ?></h2>

<form method="post" action="options.php">
    <?php settings_fields( 'vcu-settings-group' ); ?>
    <table class="form-table">
        
<!-- INSTALL URL -->
        <tr valign="top">
        <th scope="row"><?php _e('SSP install URL', 'vcu-plugin') ?></th>
        <td><input size="30" style="width:97%" type="text" name="vcu_option_name" value="<?php echo get_option('vcu_option_name'); ?>" />
        <br/>&nbsp;&nbsp;<em>ex: http://domain.com/ssp</em>
        </td> 
        </tr>  

<!-- DIMENSIONS -->
        <tr valign="top">
        <th scope="row"><?php _e('Width', 'vcu-plugin') ?></th>
        <td><input size="30" style="width:150px" type="text" name="vcu_option_width" value="<?php echo get_option('vcu_option_width'); ?>" /></td>
        </tr>  
 
 		<tr valign="top">
        <th scope="row"><?php _e('Height', 'vcu-plugin') ?></th>
        <td><input size="30" style="width:150px" type="text" name="vcu_option_height" value="<?php echo get_option('vcu_option_height'); ?>" /></td>
        </tr>
 
<!-- STYLE -->
        <tr valign="top">
        <th scope="row"><?php _e('Style', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_style" value="<?php echo get_option('vcu_option_style'); ?>">
			<option value="card" <?php if (get_option('vcu_option_style') == 'card') { echo 'selected="selected"'; } ?> >Card</option>
			<option value="chrome" <?php if (get_option('vcu_option_style') == 'chrome') { echo 'selected="selected"'; } ?> >Chrome</option>
			<option value="chromeless" <?php if (get_option('vcu_option_style') == 'chromeless') { echo 'selected="selected"'; } ?> >Chromeless</option>
			<option value="default" <?php if (get_option('vcu_option_style') == 'default') { echo 'selected="selected"'; } ?> >Default</option>
			<option value="glass" <?php if (get_option('vcu_option_style') == 'glass') { echo 'selected="selected"'; } ?> >Glass</option>
			<option value="ice" <?php if (get_option('vcu_option_style') == 'ice') { echo 'selected="selected"'; } ?> >Ice</option>
			<option value="mist" <?php if (get_option('vcu_option_style') == 'mist') { echo 'selected="selected"'; } ?> >Mist</option>
			<option value="rain" <?php if (get_option('vcu_option_style') == 'rain') { echo 'selected="selected"'; } ?> >Rain</option>
			<option value="salt" <?php if (get_option('vcu_option_style') == 'salt') { echo 'selected="selected"'; } ?> >Salt</option>
			<option value="single-video" <?php if (get_option('vcu_option_style') == 'single-video') { echo 'selected="selected"'; } ?> >Single Video</option>
			<option value="smooth" <?php if (get_option('vcu_option_style') == 'smooth') { echo 'selected="selected"'; } ?> >Smooth</option>
			<option value="techno" <?php if (get_option('vcu_option_style') == 'techno') { echo 'selected="selected"'; } ?> >Techno</option>
		</select>
        </td> 
        </tr> 
 
<!-- CONTENT SCALE -->
        <tr valign="top">
        <th scope="row"><?php _e('Content Scale', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_content_scale" value="<?php echo get_option('vcu_option_content_scale'); ?>">
			<option value="Downscale Only" <?php if (get_option('vcu_option_content_scale') == 'Downscale Only') { echo 'selected="selected"'; } ?> >Downscale Only</option>
			<option value="Proportional" <?php if (get_option('vcu_option_content_scale') == 'Proportional') { echo 'selected="selected"'; } ?> >Proportional</option>
			<option value="Crop to Fit" <?php if (get_option('vcu_option_content_scale') == 'Crop to Fit') { echo 'selected="selected"'; } ?> >Crop to Fit</option>
			<option value="Crop to Fit All" <?php if (get_option('vcu_option_content_scale') == 'Crop to Fit All') { echo 'selected="selected"'; } ?> >Crop to Fit All</option>
		</select>
        </td> 
        </tr>


<!-- TRANSITION -->
		<tr valign="top">
        <th scope="row"><?php _e('Transition', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_transition" value="<?php echo get_option('vcu_option_transition'); ?>">
			<option value="Blur" <?php if (get_option('vcu_option_transition') == 'Blur') { echo 'selected="selected"'; } ?> >Blur</option>
			<option value="Cross Fade" <?php if (get_option('vcu_option_transition') == 'Cross Fade') { echo 'selected="selected"'; } ?> >Cross Fade</option>
			<option value="Fade to Background" <?php if (get_option('vcu_option_transition') == 'Fade to Background') { echo 'selected="selected"'; } ?> >Fade to Background</option>
			<option value="Dissolve" <?php if (get_option('vcu_option_transition') == 'Dissolve') { echo 'selected="selected"'; } ?> >Dissolve</option>
			<option value="Drop" <?php if (get_option('vcu_option_transition') == 'Drop') { echo 'selected="selected"'; } ?> >Drop</option>
			<option value="Lens" <?php if (get_option('vcu_option_transition') == 'Lens') { echo 'selected="selected"'; } ?> >Lens</option>
			<option value="Photo Flash" <?php if (get_option('vcu_option_transition') == 'Photo Flash') { echo 'selected="selected"'; } ?> >Photo Flash</option>
			<option value="Push" <?php if (get_option('vcu_option_transition') == 'Push') { echo 'selected="selected"'; } ?> >Push</option>
			<option value="Wipe" <?php if (get_option('vcu_option_transition') == 'Wipe') { echo 'selected="selected"'; } ?> >Wipe</option>
			<option value="Wipe and Fade" <?php if (get_option('vcu_option_transition') == 'Wipe and Fade') { echo 'selected="selected"'; } ?> >Wipe and Fade</option>
			<option value="Wipe to Background" <?php if (get_option('vcu_option_transition') == 'Wipe to Background') { echo 'selected="selected"'; } ?> >Wipe to Background</option>
			<option value="Wipe and Fade to Background" <?php if (get_option('vcu_option_transition') == 'Wipe and Fade to Background') { echo 'selected="selected"'; } ?> >Wipe and Fade to Background</option>
		</select>
        </td> 
        </tr> 


<!-- PRELOADER -->
		<tr valign="top">
        <th scope="row"><?php _e('Preloader', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_preloader" value="<?php echo get_option('vcu_option_preloader'); ?>">
			<option value="Hidden" <?php if (get_option('vcu_option_preloader') == 'Hidden') { echo 'selected="selected"'; } ?> >Hidden</option>
			<option value="Bar" <?php if (get_option('vcu_option_preloader') == 'Bar') { echo 'selected="selected"'; } ?> >Bar</option>
			<option value="Beam" <?php if (get_option('vcu_option_preloader') == 'Beam') { echo 'selected="selected"'; } ?> >Beam</option>
			<option value="Line" <?php if (get_option('vcu_option_preloader') == 'Line') { echo 'selected="selected"'; } ?> >Line</option>
			<option value="Pie" <?php if (get_option('vcu_option_preloader') == 'Pie') { echo 'selected="selected"'; } ?> >Pie</option>
			<option value="Pie Spinner" <?php if (get_option('vcu_option_preloader') == 'Pie Spinner') { echo 'selected="selected"'; } ?> >Pie Spinner</option>
			<option value="Spinner" <?php if (get_option('vcu_option_preloader') == 'Spinner') { echo 'selected="selected"'; } ?> >Spinner</option>
		</select>
        </td> 
        </tr> 

<!-- AUTO PLAYBACK -->
		<tr valign="top">
        <th scope="row"><?php _e('Auto Playback', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_auto_playback" value="<?php echo get_option('vcu_option_auto_playback'); ?>">
			<option value="" <?php if (get_option('vcu_option_auto_playback') == '') { echo 'selected="selected"'; } ?> >Auto</option>
			<option value="Manual" <?php if (get_option('vcu_option_auto_playback') == 'Manual') { echo 'selected="selected"'; } ?> >Manual</option>
		</select>
        </td> 
        </tr> 
		
<!-- PANZOOM	 -->
		<tr valign="top">
        <th scope="row"><?php _e('Pan Zoom', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_pan_zoom" value="<?php echo get_option('vcu_option_pan_zoom'); ?>">
			<option value="Off" <?php if (get_option('vcu_option_pan_zoom') == 'Off') { echo 'selected="selected"'; } ?> >Off</option>
			<option value="On" <?php if (get_option('vcu_option_pan_zoom') == 'On') { echo 'selected="selected"'; } ?> >On</option>
		</select>
        </td> 
        </tr> 
		

<!-- MOUSEOVER NAVIGATION -->
		<tr valign="top">
        <th scope="row"><?php _e('Mouseover Navigation', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_mouseover_navigation" value="<?php echo get_option('vcu_option_mouseover_navigation'); ?>">
			<option value="Visible on Rollover" <?php if (get_option('vcu_option_mouseover_navigation') == 'Visible on Rollover') { echo 'selected="selected"'; } ?> >On</option>
			<option value="Off" <?php if (get_option('vcu_option_mouseover_navigation') == 'Off') { echo 'selected="selected"'; } ?> >Off</option>
		</select>
        </td> 
        </tr> 

<!-- OPEN GALLERY -->
		<tr valign="top">
        <th scope="row"><?php _e('Open Gallery', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_open_gallery" value="<?php echo get_option('vcu_option_open_gallery'); ?>">
			<option value="Off" <?php if (get_option('vcu_option_open_gallery') == 'Off') { echo 'selected="selected"'; } ?> >Off</option>
			<option value="Open Gallery" <?php if (get_option('vcu_option_open_gallery') == 'Open Gallery') { echo 'selected="selected"'; } ?> >On</option>
		</select>
        </td> 
        </tr> 

<!-- AUTO START VIDEOS -->
		<tr valign="top">
        <th scope="row"><?php _e('Auto Start Videos', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_auto_start_videos" value="<?php echo get_option('vcu_option_auto_start_videos'); ?>">
			<option value="Off" <?php if (get_option('vcu_option_auto_start_videos') == 'Off') { echo 'selected="selected"'; } ?> >Off</option>
			<option value="On" <?php if (get_option('vcu_option_auto_start_videos') == 'On') { echo 'selected="selected"'; } ?> >On</option>
		</select>
        </td> 
        </tr> 
        
<!-- THUMBNAIL LINKS -->
		<tr valign="top">
        <th scope="row"><?php _e('Thumbnail Links', 'vcu-plugin') ?></th>
        <td>
        <select size="1" style="width:150px" name="vcu_option_thumbnail_links" value="<?php echo get_option('vcu_option_thumbnail_links'); ?>">
			<option value="" <?php if (get_option('vcu_option_thumbnail_links') == '') { echo 'selected="selected"'; } ?> >On</option>
			<option value="Numbers" <?php if (get_option('vcu_option_thumbnail_links') == 'Numbers') { echo 'selected="selected"'; } ?> >Off</option>
		</select>
        </td> 
        </tr> 
        
        
        
        	
               
    </table>
    
    <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes', 'vcu-plugin') ?>" /> 
    </p>

</form>

</div>
<?php } 





/* SHORTCODE */
add_shortcode('slideShowProSC','slideShowProSC');  
function slideShowProSC($atts, $content = null){

	$ssp_install = get_option('vcu_option_name');
	$ssp_style = get_option('vcu_option_style');
	$ssp_content_scale = get_option('vcu_option_content_scale');
	$ssp_transition = get_option('vcu_option_transition');
	$ssp_preloader = get_option('vcu_option_preloader');
	$ssp_auto_playback = get_option('vcu_option_auto_playback');
	$ssp_pan_zoom = get_option('vcu_option_pan_zoom');
	$ssp_mouseover_navigation = get_option('vcu_option_mouseover_navigation');
	$ssp_open_gallery = get_option('vcu_option_open_gallery');
	$ssp_auto_start_videos = get_option('vcu_option_auto_start_videos');
	
/* 	SET THUMBNAILS VARIABLE TO ONLY DISPLAY IF SET */
	if (get_option('vcu_option_thumbnail_links') == 'Numbers' ) {
	$ssp_thumbnail_links = 'navLinkAppearance: "Numbers",';	
	} else {
	$ssp_thumbnail_links = '';
	}
	
/* 	EXTRACT ATTRIBUTES SET IN THE SHORTCODE */
	extract(shortcode_atts(array(
		"width" => '',
		"height" => '',
		"album" => ''
	), $atts));

/* IF ATTRIBUTES ARE SET IN SHORTCODE OVERRIDE THE ADMIN SETTINGS	 */
	if ($atts["width"] == '') {
	$width = get_option('vcu_option_width');
	}
	
	if ($atts["height"] == '') {
	$height = get_option('vcu_option_height');
	}
	
	echo $shortcode_atts['height'];

	return '<!-- START EMBED CODE -->

				<script type="text/javascript" src="'.$ssp_install.'/m/embed.js"></script>
				
				<div id="album-'.$album.'">
				
				</div>
				
				<script type="text/javascript">
					SlideShowPro({
						attributes: {
							id: "album-'.$album.'",
							width: '.$width.',
							height: '.$height.'
						},
						mobile: {
							auto: false
						},
						params: {
							bgcolor: "#000000",
							allowfullscreen: true
						},
						flashvars: {
							xmlFilePath: "'.$ssp_install.'/images.php?album='.$album.'",
							paramXMLPath: "'.$ssp_install.'/m/params/'.$ssp_style.'.xml",
							transitionStyle: "'.$ssp_transition.'",
							feedbackPreloaderAppearance: "'.$ssp_preloader.'",
							contentScale: "'.$ssp_content_scale.'",
							displayMode: "'.$ssp_auto_playback.'",
							panZoom: "'.$ssp_pan_zoom.'",
							navAppearance: "'.$ssp_mouseover_navigation.'",
							startup: "'.$ssp_open_gallery.'",
							videoAutoStart: "'.$ssp_auto_start_videos.'",
							'.$ssp_thumbnail_links.'
						}
					});
				</script>
			
			<!-- END EMBED CODE -->';
}

/* ADD SHORTCODE BUTTONS TO MCE */
add_action('init', 'add_button');  

function add_button() {  
   if ( current_user_can('edit_posts') &&  current_user_can('edit_pages') )  
   {  
     add_filter('mce_external_plugins', 'add_plugin');  
     add_filter('mce_buttons', 'register_button');  
   }  
}  

function register_button($buttons) {  
   array_push($buttons, "slideShowProSC");  
   return $buttons;  
}  

function add_plugin($plugin_array) {  
   $plugin_array['shortcodeBtns'] = WP_PLUGIN_URL.'/slideshowpro-shortcode/shortcode.js';  
   return $plugin_array;  
} 
?>